<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_treatment".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderTreatment".
 *
 * Columns in table "provider_treatment" available as properties of the model,
 * followed by relations of table "provider_treatment" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $treatment_id
 *
 * @property Provider $provider
 * @property Treatment $treatment
 */
abstract class BaseProviderTreatment extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_treatment';
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('provider_id, treatment_id', 'required'),
            array('provider_id, treatment_id', 'numerical', 'integerOnly' => true),
            array('id, provider_id, treatment_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'treatment' => array(self::BELONGS_TO, 'Treatment', 'treatment_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'treatment_id' => Yii::t('app', 'Treatment'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->with = array('treatment', 'provider');

        //it will search by id or provider.first_last
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->with[] = 'provider';
            $criteria->addSearchCondition("provider.first_last", $this->provider_id);
        } else
            $criteria->compare('provider_id', $this->provider_id);

        if (!intval($this->treatment_id) && is_string($this->treatment_id) && strlen($this->treatment_id) > 0) {
            $criteria->with[] = 'treatment';
            $criteria->addSearchCondition("treatment.name", $this->treatment_id);
        } else
            $criteria->compare('treatment_id', $this->treatment_id);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderTreatment|ProviderTreatments', $n);
    }

}
